#include <stdio.h>
#include <string>
#include <iostream>

#ifdef FLASHPROIMOTION
#include "../FlashProiMOTION-Dll.h"
#endif

#ifdef GANGPROIMOTION
#include "../GangProiMOTION-Dll.h"
#endif

#include <pthread.h>

using namespace std;

void *thread_func (void *arg)
{
  F_AutoProgram();
  return NULL;
}

int main(int argc, char* argv[])
{
  int st;

  string input = "*# *";
  if(argc < 3)
  {
    cout<< "Usage: <config> <code>" << endl;
    return 1;
  }
  pthread_t tid;
  int param;
  void *ret;
    
  F_Trace_ON();
  cout << "F_OpenInstancesAndFPAs : " << dec <<   F_OpenInstancesAndFPAs((char *)input.c_str()) << endl;
  cout << "F_Get_FPA_SN : " << F_Get_FPA_SN(1) << endl;
  cout << "F_Set_FPA_index : " << dec << F_Set_FPA_index (0) << endl;
  cout << "F_Initialization : " << dec << F_Initialization() << endl;
  cout << "API Version " << hex << (0xFFF & F_DLLTypeVer()) << endl;
  cout << "Multi Version " << hex << (0xFFF & F_Multi_DLLTypeVer()) << endl;
  F_Set_FPA_index(1);
  cout << "F_ConfigFileLoad : " << dec << F_ConfigFileLoad( argv[1] ) << endl;
  cout << "F_ReadCodeFile : " << dec << F_ReadCodeFile( argv[2] ) << endl;

  pthread_create(&tid, NULL, thread_func, (void *)&param);

  for(int i=0; i<100000; i++);
  F_CancelAction(1);
  
  pthread_join(tid, &ret);
  
  F_Trace_OFF();
  cout << F_Report_Message() << endl;
  
  return 0;
}
